__gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > Class Template Reference
Extensions » Policy-Based Data Structures » Containers » Branch-Based » Base and Policy Classes
Inheritance diagram for __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >:
[legend]

## Classes

class | cond_dtor

## Public Types

typedef _Alloc | allocator_type
typedef Cmp_Fn | cmp_fn
typedef std::pair< size_type, size_type > | comp_hash
typedef point_const_iterator | const_iterator
typedef traits_base::const_pointer | const_pointer
typedef traits_base::const_reference | const_reference
typedef ov_tree_tag | container_category
typedef _Alloc::difference_type | difference_type
typedef point_iterator | iterator
typedef traits_base::key_const_pointer | key_const_pointer
typedef traits_base::key_const_reference | key_const_reference
typedef traits_base::key_pointer | key_pointer
typedef traits_base::key_reference | key_reference
typedef traits_base::key_type | key_type
typedef traits_base::mapped_const_pointer | mapped_const_pointer
typedef traits_base::mapped_const_reference | mapped_const_reference
typedef traits_base::mapped_pointer | mapped_pointer
typedef traits_base::mapped_reference | mapped_reference
typedef traits_base::mapped_type | mapped_type
typedef __nothrowcopy::indicator | no_throw_indicator
typedef traits_type::node_const_iterator | node_const_iterator
typedef traits_type::node_iterator | node_iterator
typedef traits_type::node_update | node_update
typedef const_pointer | point_const_iterator
typedef pointer | point_iterator
typedef traits_base::pointer | pointer
typedef traits_base::reference | reference
typedef _Alloc::size_type | size_type
typedef integral_constant< int, Store_Hash > | store_extra
typedef traits_base::value_type | value_type

## Public Member Functions

| ov_tree_map (const Cmp_Fn &)
| ov_tree_map (const Cmp_Fn &, const node_update &)
| ov_tree_map (const ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > &)
iterator | begin ()
const_iterator | begin () const
void | clear ()
template<typename It >
void | copy_from_range (It, It)
bool | empty () const
iterator | end ()
const_iterator | end () const
bool | erase (key_const_reference)
iterator | erase (iterator it)
template<typename Pred >
size_type | erase_if (Pred)
point_iterator | find (key_const_reference r_key)
point_const_iterator | find (key_const_reference r_key) const
Cmp_Fn & | get_cmp_fn ()
const Cmp_Fn & | get_cmp_fn () const
std::pair< point_iterator, bool > | insert (const_reference r_value)
void | join (ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > &)
point_iterator | lower_bound (key_const_reference r_key)
point_const_iterator | lower_bound (key_const_reference r_key) const
size_type | max_size () const
node_const_iterator | node_begin () const
node_iterator | node_begin ()
node_const_iterator | node_end () const
node_iterator | node_end ()
mapped_reference | operator[] (key_const_reference r_key)
size_type | size () const
void | split (key_const_reference, ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > &)
void | swap (ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > &)
point_iterator | upper_bound (key_const_reference r_key)
point_const_iterator | upper_bound (key_const_reference r_key) const

## Public Attributes

no_throw_indicator | m_no_throw_copies_indicator
store_extra | m_store_extra_indicator

## Detailed Description

### template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>
class __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >

Ordered-vector tree associative-container.

Definition at line 106 of file ov_tree_map_.hpp.

## Member Function Documentation

## node_begin() [1/2]

template<typename Key , typename Mapped , typename Cmp_Fn , typename Node_And_It_Traits , typename _Alloc >

ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_const_iterator __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_begin | ( |  | ) | const

inline

Returns a const node_iterator corresponding to the node at the root of the tree.

Definition at line 45 of file ov_tree_map_.hpp.

## node_begin() [2/2]

template<typename Key , typename Mapped , typename Cmp_Fn , typename Node_And_It_Traits , typename _Alloc >

ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_iterator __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_begin | ( |  | ) |

inline

Returns a node_iterator corresponding to the node at the root of the tree.

Definition at line 57 of file ov_tree_map_.hpp.

## node_end() [1/2]

template<typename Key , typename Mapped , typename Cmp_Fn , typename Node_And_It_Traits , typename _Alloc >

ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_const_iterator __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_end | ( |  | ) | const

inline

Returns a const node_iterator corresponding to a node just after a leaf of the tree.

Definition at line 51 of file ov_tree_map_.hpp.

## node_end() [2/2]

template<typename Key , typename Mapped , typename Cmp_Fn , typename Node_And_It_Traits , typename _Alloc >

ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_iterator __gnu_pbds::detail::ov_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_end | ( |  | ) |

inline

Returns a node_iterator corresponding to a node just after a leaf of the tree.

Definition at line 63 of file ov_tree_map_.hpp.

The documentation for this class was generated from the following file:

- ov_tree_map_.hpp